const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const marketplace_orders = sequelize.define(
    'marketplace_orders',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency: {
        type: DataTypes.ENUM,
      
      

        values: [

"ZAR",


"USD",


"EUR",


"GBP"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"paid",


"fulfilled",


"refunded",


"canceled"

        ],

      },

ordered_at: {
        type: DataTypes.DATE,
      
      

      },

fulfilled_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  marketplace_orders.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.marketplace_orders.belongsTo(db.marketplace_listings, {
      as: 'listing',
      foreignKey: {
        name: 'listingId',
      },
      constraints: false,
    });

    db.marketplace_orders.belongsTo(db.users, {
      as: 'buyer_user',
      foreignKey: {
        name: 'buyer_userId',
      },
      constraints: false,
    });

    db.marketplace_orders.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.marketplace_orders.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.marketplace_orders.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return marketplace_orders;
};


